#ifndef _ASM_HARDWARE_SNAPPER_H
#define _ASM_HARDWARE_SNAPPER_H

#include <linux/init.h>
#include <linux/module.h>
#include <linux/string.h>

#define SNAPPER_BASEBOARD(name, init_func)				\
	static char *__baseboard;					\
	static int __init __##name##_baseboard_setup(char *str)		\
	{								\
		__baseboard = str;					\
		return 0;						\
	}								\
	int snapper_baseboard_is_##name(void)				\
	{								\
		if (__baseboard)					\
			return (strcasecmp(__baseboard,			\
					   #name) == 0) ? 1 : 0;	\
		return 0;						\
	}								\
	EXPORT_SYMBOL(snapper_baseboard_is_##name);			\
	static int __init __##name##_init(void)				\
	{								\
		if (snapper_baseboard_is_##name()) {			\
			pr_info("Initialising %s Snapper baseboard\n",	\
				#name);					\
			init_func();					\
		}							\
		return 0;						\
	}								\
	__setup("snapper_baseboard=", __##name##_baseboard_setup);	\
	arch_initcall(__##name##_init)

/* FIXME - ick */
#ifdef CONFIG_MACH_RIG200
extern int snapper_baseboard_is_rig200(void);
#else
#define snapper_baseboard_is_rig200() 0
#endif

#ifdef CONFIG_MACH_SALMON
extern int snapper_baseboard_is_salmon(void);
#else
#define snapper_baseboard_is_salmon() 0
#endif

#ifdef CONFIG_MACH_TRUMPETER
extern int snapper_baseboard_is_trumpeter(void);
#else
#define snapper_baseboard_is_trumpeter() 0
#endif

#ifdef CONFIG_MACH_SN9260_QSK
extern int snapper_baseboard_is_sn9260_qsk(void);
#else
#define snapper_baseboard_is_sn9260_qsk() 0
#endif

#ifdef CONFIG_MACH_OREO_TEST_BOARD
extern int snapper_baseboard_is_oreo_test_board(void);
#else
#define snapper_baseboard_is_oreo_test_board() 0
#endif

#endif /* _ASM_HARDWARE_SNAPPER_H */
