#ifndef __ASM_ARCH_SPI_H
#define __ASM_ARCH_SPI_H

/**
 * struct ep93xx_spi_master - platform_data for the SPI bus
 * @num_chipselects:	number of devices on the bus
 */
struct ep93xx_spi_master {
	u16	num_chipselects;
};

/**
 * struct ep93xx_spi_chip  - Control structure for SPI slave device
 * @setup:	function to setup the chip select mechanism
 * @cleanup:	function to cleanup the chip select mechanism
 * @cs_control:	function to control the device chip select
 */
struct ep93xx_spi_chip {
	int	(*setup)(void);
	void	(*cleanup)(void);
	void	(*cs_control)(int active, int activehigh);
};

#endif /* __ASM_ARCH_SPI_H */
